#include "key.h"

NOu16 Count[8] = {0};
NOu8 LastState = 0;  // 8位变量，B0 = 1 代表KEY0上一次按下过


void KEY_Deal(void)	// 检查所有按键状态
{
	NOu8 i = 0;
	for(i=0; i<8; i++)				// 循环8次，查询P30-P37状态查询
	{
		if(~KEY & ( 1 << i ))		// 持续按下，变量+1
		{
			if( Count[i]<60000 )
				Count[i]++;			// 按下+1
		}
		else						// 松开变量清零
		{
			if(Count[i] > 0)		// 如果这个变量按下过
			{
				LastState |= (1<<i);	// 这个变量相应的标志位置位
			}
			else
			{
				LastState &= ~(1<<i);	// 这个变量相应的标志位置位
			}
			Count[i] = 0;			// 按键松开，这个计数变量清0
		}
	}
}


NOu8 KEY_ReadState(NOu8 keynum)	// 读取指定的按键状态
{
	if(Count[keynum] > 0)
	{
		if(Count[keynum] < 3)		// 按下<30ms 返回消抖状态
		{
			return KEY_FILCKER;
		}
		else if(Count[keynum] == 3)	// 按下=30ms 返回单击
		{
			return KEY_PRESS;
		}
		else if(Count[keynum] < 300)	// 按下不到3000ms 返回单击结束
		{
			return KEY_PRESSOVER;
		}
		else if(Count[keynum] == 300)	// 按下=3000ms 返回长按
		{
			return KEY_LONGPRESS;
		}
		else						// 按下>3000ms 返回长按结束
		{
			return KEY_LONGOVER;
		}
	}
	else						// 按键已经松开了
	{
		if( LastState &= (1<<keynum) )
		{
			return KEY_RELAX;		// 如果之前按下过
		}
		else
		{
			return KEY_NOPRESS;		// 按键之前没按下过
		}
	}
}