#include "seg_led.h"


NOu8 SEG_Tab[] = {0xC0, 0xF9, 0xA4, 0xB0, 0x99, 0x92, 0x82, 0xF8, 0x80, 0x90, 0xBF, 0xFF};  // 这里不写多少也行，会算出来
NOu8 SEGarr_TAB[8] = {0, 1, 2, 3, 4, 5, 6, 7};

NOu8 bdata LED_DATA = 0xFF;
sbit LED0 = LED_DATA^0;
sbit LED1 = LED_DATA^1;
sbit LED2 = LED_DATA^2;
sbit LED3 = LED_DATA^3;
sbit LED4 = LED_DATA^4;
sbit LED5 = LED_DATA^5;
sbit LED6 = LED_DATA^6;
sbit LED7 = LED_DATA^7;

/*
函数功能：单个数码管显示对应字符
入口参数：@NOu8 P7index：数码管COM口  @NOu8 showtabindex：显示SEG_Tab数组中第几个
函数返回：
其他备注：
*/
void SEG1show(NOu8 P7index, NOu8 showtabindex)  // P7index 从0开始
{
    NOu8 indexnum = 0x01;
	P6 = 0xFF;
    P7 = ~(indexnum << (8 - P7index - 1));
    P6 = SEG_Tab[showtabindex];
}

/*
函数功能：一组数码管显示
入口参数：@
函数返回：
其他备注：
*/
void SEGarr_show()
{
	static NOu8 i = 0;
	if(i > 7)
	{
		i = 0;
	}
	SEG1show(i, SEGarr_TAB[i]);
	i++;
}

/*
函数功能：数码管和LED一起显示
入口参数：@
函数返回：
其他备注：i是静态变量，只有在第一次执行的之后赋初值
			以后每次执行这个函数，都会执行后面的 i++ 约等于全局变量
*/

void SEGLEDarr_show()
{
	static NOu8 i = 0;
	if (i <= 7)
	{
		SEG1show(i, SEGarr_TAB[i]);
	}
	else if(i <= 8)
	{
		LED_POW = 0;
		SEG_COM = 0xFF;
		SEG_SEG = LED_DATA;
	}
	else
	{
		LED_POW = 1;
		SEG_COM = 0xFF;
		SEG_SEG = 0xFF;
	}
	i++;
	if(i >= 10)
	{
		i = 0;
	}
}
